'From Haver 5.0 [latest update: #4559] on 22 March 2021 at 6:09:38 pm'!
'Description Tests for the ActionBuilder package.'!
!provides: 'ActionBuilderTest' 1 10!
!requires: 'ActionBuilder' 1 14 nil!
SystemOrganization addCategory: 'ActionBuilderTest'!


!moduleCreation: ActionBuilderTest!
Modules newEnvironment: #ActionBuilderTest!

!interfacesOf: ActionBuilderTest!
Modules environment: #ActionBuilderTest ::
	interface: #API exporting: #() ::
	interface: #SPI aliasFor: #API!

!importsOf: ActionBuilderTest!
Modules environment: #ActionBuilderTest :: 
	import: #UTI of: Modules>>#ActionBuilder :: 
	import: #API of: Modules>>#ActionBuilder!

!classDefinition: (Modules>>#ActionBuilderTest>>#ABTest) category: 'ActionBuilderTest'!
HaverDarkTheme subclass: #ABTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilderTest'
	inModule: #ActionBuilderTest!
!classDefinition: (Modules>>#ActionBuilderTest>>#ABTest) class category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#ABTest) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) category: 'ActionBuilderTest'!
TestCase subclass: #AbstractDescriptionTestCase
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilderTest'
	inModule: #ActionBuilderTest!
!classDefinition: (Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) class category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilderTest>>#DescriptionTestCase) category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) subclass: #DescriptionTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilderTest'
	inModule: #ActionBuilderTest!
!classDefinition: (Modules>>#ActionBuilderTest>>#DescriptionTestCase) class category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#DescriptionTestCase) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ActionBuilderTest>>#RealWorldTestCase) category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) subclass: #RealWorldTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActionBuilderTest'
	inModule: #ActionBuilderTest!
!classDefinition: (Modules>>#ActionBuilderTest>>#RealWorldTestCase) class category: 'ActionBuilderTest'!
(Modules>>#ActionBuilderTest>>#RealWorldTestCase) class
	instanceVariableNames: ''!


!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) commentStamp: '<historical>' prior: 0!
I am a real word test case.!

!(Modules>>#ActionBuilderTest>>#ABTest) methodsFor: 'other options' stamp: 'KLG 12/19/2020 21:56:12'!
embossedButtonLabels
	"Currently only apply to rounded buttons!!"

	^ false! !

!(Modules>>#ActionBuilderTest>>#AbstractDescriptionTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/10/2020 20:42:27'!
setUp
	"Create a builder."

	builder _ ActionBuilder new! !

!(Modules>>#ActionBuilderTest>>#DescriptionTestCase) methodsFor: 'testing' stamp: 'KLG 12/10/2020 18:38:36'!
testActionGroupAccessors
	"Test for automatically defined accesors.."

	builder
		newRootActionGroup: #testActions2 forModel: self buildDoing: [ :root |
			self 
				assert: #testActions2 equals: root selector;
				assert: nil equals: root owner;
				assert: root equals: builder current.
			builder 
				newAction: #action1 buildDoing: [ :action |
					self
						assert: #action1 equals: action actionSelector;
						assert: builder current equals: action;
					 	assert: root equals: action owner;
						assert: self equals: action model ];
				newActionGroup: #group1 buildDoing: [ :group |
					self
						assert: #group1 equals: group selector;
						assert: builder current equals: group;
					 	assert: root equals: group owner ].
					builder
						newAction: #action2 buildDoing: [ :action |
							self
								assert: #action2 equals: action actionSelector;
								assert: builder current equals: action;
							 	assert: root equals: action owner;
								assert: self equals: action model  ]							]! !

!(Modules>>#ActionBuilderTest>>#DescriptionTestCase) methodsFor: 'testing' stamp: 'KLG 12/10/2020 18:10:38'!
testActionOwnerShip
	"Simple owner-ship test."

	builder
		newRootActionGroup: #testActions1 forModel: self  buildDoing: [ :root |
			builder newAction: #action1 buildDoing: [ :action |
				self assert: root equals: action owner ] ]! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/13/2020 22:44:10'!
setUp
	"Setup a realword test case taken from the modules tools module."

	super setUp.
	! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'testing' stamp: 'KLG 12/19/2020 15:33:10'!
testImportListMenu
	"Test the ported import menu."
	
	| menu buttons |
	builder
		newRootActionGroup: #testImportListMenu forModel: self buildDoing: [ :root |
			root heading: 'Imports'.
			builder
				newActionGroup: #importedInterfaces buildDoing: [
					builder 
						newAction: #newImport buildDoing: [ :newImport |
							newImport
								text: 'New import...';
								buttonText: 'New ...';
								icon: #newIcon;
								balloonText: 'Create a new import' ];
						newAction: #removeImport buildDoing: [ :removeImport |
							removeImport
								text: 'Remove import...';
								buttonText: 'Remove ...;';
								icon: #deleteIcon;
								balloonText: 'Remove' red, ' the selected import' bold;
								enabledSelector: #hasImportSpecificationSelection ];
						newAction: #importWholeInterface buildDoing: [ :importWholeInterface |
							importWholeInterface
								text: 'Import whole interface...';
								buttonText: 'Import all ...';
								balloonText: 
									'Import every symbol of the interface. Remove all explictly imported symbols.';
								enabledSelector: #hasExplicitImportSpecificationSelection ];
						newAction: #toggleExcludeImportedNames buildDoing: [ :exclude |
							exclude
								text: 'Exclude names';
								buttonText: 'Exclude';
								model: self;
								balloonText:
									'Do not include the specified names, but import all other names in the interface' ;
								enabledSelector: #hasExplicitImportSpecificationSelection;
								selectedSelector: #excludesImportedNames ] ];
				newActionGroup: #importedSymbols buildDoing: [
					builder
						newAction: #editImport buildDoing: [ :editImport |
							editImport 
								text: #editText;
								model: self;
								icon: #textEditorIcon;
								balloonText: #editBalloonText;
								enabledSelector: #hasImportedSymbolSpecificationSelectionAndNoExclude ];
						newAction: #removeImportedSymbol buildDoing: [ :removeSymbol |
							removeSymbol
								text: 'Remove ...';
								icon: #deleteIcon;
								balloonText: #removeBalloonText;
								enabledSelector: #hasImportedSymbolSpecificationSelection ] ] ].
	menu _ builder menuBuilder buildUIElement.
	self assert: (menu isKindOf: MenuMorph).
	menu openInWorld.
	buttons _ builder buttonsBuilder buildUIElement.
	buttons openInWorld
! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'testing' stamp: 'KLG 12/18/2020 17:36:17'!
testModulesListActions
	"Test the ported modules list menu."

	| menu |
	builder
		newRootActionGroup: #modulesListAction forModel: self buildDoing: [ :root |
			root heading: 'Modules'.
			builder
				newActionGroup: #changeModule buildDoing: [ :change |
					builder
						newAction: #newModule buildDoing: [ :newModule |
							newModule
								text: 'New module ...';
								icon: #newIcon;
								balloonText: 'Create a new module'					];
						newAction: #deleteModule buildDoing: [ :deleteModule |
							deleteModule
								text: 'Remove module ...';
								icon: #deleteIcon;
								balloonText: 'Remove the selected module';
								enabledSelector: #hasModuleSelection ];
						newAction: #renameModule buildDoing: [ :renameModule |
							renameModule
								text: 'Rename module ...';
								icon: #textEditorIcon;
								balloonText: 'Reanme the selected module';
								enabledSelector: #hasModuleSelection ] ];
			 	newActionGroup: #genericEdit buildDoing: [ :edit |
					builder
						newAction: #browseSelection buildDoing: [ :browseSelection |
							browseSelection
								text: 'Browse it';
								icon: #editFindReplaceIcon;
								balloonText: 'Browse the selected item or its class';
								enabledSelector: #hasSelection ];
						newAction: #inspectSelection buildDoing: [ :inspectSelection |
							inspectSelection
								text: 'Inspect it';
								icon: #inspectIcon;
								balloonText: 'Inspect the selected item or its class';
								enabledSelector: #hasSelection ];
						newAction: #exploreSelection buildDoing: [ :exploreSelection |
							exploreSelection
								text: 'Explore it';
								icon: #exploreIcon;
								balloonText: 'Explore the selected item or its class';
								enabledSelector: #hasSelection ] ] ].
	menu _ builder menuBuilder buildUIElement.
	self assert: (menu isKindOf: MenuMorph).
	"D: menu openInWorld"
! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/19/2020 13:15:04'!
editBalloonText
	"Mock the balloon text callback."
	
	^ 'Edit balloon text from call back' ! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:41:18'!
editText
	"Mock the text callback."
	
	^ 'Edit ... (from call back)' ! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:48:45'!
excludesImportedNames
	"YAMU"
	
	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:21:43'!
hasExplicitImportSpecificationSelection
	"Antother mockup."
	
	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:21:10'!
hasImportSpecificationSelection
	"Mock this selector".

	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:23:28'!
hasImportedSymbolSpecificationSelection
	"YAMU"
	
	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/19/2020 21:43:36'!
hasImportedSymbolSpecificationSelectionAndNoExclude
	"YAMU: Yet another mock up."
	
	^ false! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 11:34:21'!
hasModuleSelection
	"Mock the module selection."
	
	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/17/2020 23:18:06'!
hasSelection
	"Mock the selection."
	
	^ true! !

!(Modules>>#ActionBuilderTest>>#RealWorldTestCase) methodsFor: 'mockup' stamp: 'KLG 12/18/2020 18:36:58'!
removeBalloonText
	"Mock the balloon text callback."
	
	^ 'Remove balloon text from call back' ! !
