'From Haver 6.0 [latest update: #5170] on 17 May 2022 at 9:58:31 pm'!
'Description '!
!provides: 'PackageIntegrators' 1 10!
SystemOrganization addCategory: 'PackageIntegrators'!


!moduleCreation: PackageIntegrators!
Modules newEnvironment: #PackageIntegrators!

!interfacesOf: PackageIntegrators!
Modules environment: #PackageIntegrators ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!


!classDefinition: (Modules>>#PackageIntegrators>>#IntegratorCodePackage) category: 'PackageIntegrators'!
(Environments>>#Modules>>#ModulesCodePackage) subclass: #IntegratorCodePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageIntegrators'
	inModule: #PackageIntegrators!
!classDefinition: (Modules>>#PackageIntegrators>>#IntegratorCodePackage) class category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) category: 'PackageIntegrators'!
Object subclass: #AbstractPackageIntegrator
	instanceVariableNames: 'package baseChangetSet'
	classVariableNames: 'IntegratedFeatures'
	poolDictionaries: ''
	category: 'PackageIntegrators'
	inModule: #PackageIntegrators!
!classDefinition: (Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) class category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PackageIntegrators>>#ChangeSetWritingPackageIntegrator) category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) subclass: #ChangeSetWritingPackageIntegrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageIntegrators'
	inModule: #PackageIntegrators!
!classDefinition: (Modules>>#PackageIntegrators>>#ChangeSetWritingPackageIntegrator) class category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#ChangeSetWritingPackageIntegrator) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PackageIntegrators>>#PackageIntegrator) category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) subclass: #PackageIntegrator
	instanceVariableNames: 'systemCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageIntegrators'
	inModule: #PackageIntegrators!
!classDefinition: (Modules>>#PackageIntegrators>>#PackageIntegrator) class category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#PackageIntegrator) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#PackageIntegrators>>#ModuleIntegrator) category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#PackageIntegrator) subclass: #ModuleIntegrator
	instanceVariableNames: 'module'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageIntegrators'
	inModule: #PackageIntegrators!
!classDefinition: (Modules>>#PackageIntegrators>>#ModuleIntegrator) class category: 'PackageIntegrators'!
(Modules>>#PackageIntegrators>>#ModuleIntegrator) class
	instanceVariableNames: ''!


!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) commentStamp: '<historical>' prior: 0!
I am a code package for used in the package integrators.

I provide means to add instance- and class-variables.!

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) commentStamp: '<historical>' prior: 0!
I integrate one package. I maybe subclassed to customize integration.!

!(Modules>>#PackageIntegrators>>#ChangeSetWritingPackageIntegrator) commentStamp: '<historical>' prior: 0!
I am a package integrator that writes change sets.!

!(Modules>>#PackageIntegrators>>#PackageIntegrator) commentStamp: '<historical>' prior: 0!
I am a package integrator that just integrates the package into the current image, but does not write a a change set.!

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'installing' stamp: 'KLG 9/9/2021 21:57:33'!
prePackageInstall
	"This gets called after creating the package class and installing its code, but before installing the rest of the package code
	Redefine as appropriate"
	
	self addNewVariables! !

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'new variables' stamp: 'KLG 9/9/2021 22:06:39'!
addNewClassVariables
	"Add new class variables."

	self classesAndClassVariableNamesToAdd keysAndValuesDo: [ :className :classVariableNames |
		Smalltalk
			at: className
			ifPresent: [ :class |
				classVariableNames do: [ :classVariableName |
					class classPool includesKey: classVariableName :: ifFalse: [
						class addClassVarName: classVariableName ] ] ] ]! !

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'new variables' stamp: 'KLG 9/9/2021 22:13:26'!
addNewInstanceVariables
	"Add new insdtance variables."

	self classesAndInstanceVariableNamesToAdd keysAndValuesDo: [ :className :instanceVariableNames |
		Smalltalk
			at: className
			ifPresent: [ :class |
				instanceVariableNames do: [ :instanceVariableName |
					class instVarNames includes: instanceVariableName :: ifFalse: [
						class addInstVarName: instanceVariableName ] ] ] ]! !

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'new variables' stamp: 'KLG 9/9/2021 22:14:02'!
addNewVariables
	"Add new instance and classvariables."

	self
		addNewClassVariables;
		addNewInstanceVariables! !

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'new variables' stamp: 'KLG 9/9/2021 21:56:07'!
classesAndClassVariableNamesToAdd
	"Answer an mapping of class names to sets of class variable names to add"

	^ `IdentityDictionary new`! !

!(Modules>>#PackageIntegrators>>#IntegratorCodePackage) class methodsFor: 'new variables' stamp: 'KLG 9/9/2021 21:56:21'!
classesAndInstanceVariableNamesToAdd
	"Answer an mapping of class names to sets of instance variable names to add"

	^ `IdentityDictionary new`! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'accessing' stamp: 'KLG 5/4/2022 09:40:01'!
integratedFeatures

	^ IntegratedFeatures ifNil: [ IntegratedFeatures _ Set new ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'accessing' stamp: 'KLG 8/27/2021 22:06:06'!
package: aStringOrPackage
	"Set the new package"

	self assert: package isNil.
	package _ aStringOrPackage isString
		ifTrue: [ CodePackage named: aStringOrPackage createIfAbsent: false registerIfNew:false ]
		ifFalse: [ aStringOrPackage ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 8/27/2021 21:59:50'!
createChangeSetPostscript
	"Create a postscript for the change set.."

	self changeSetPostScriptSourceCode ifNotNil: [ :sourceCode |
		baseChangetSet postscriptString: 
			(String streamContents: [:strm |
				strm 
					nextPutAll: '"PostScript:'  "NOTE: fileIn recognizes preambles by this string.";
					newLine; newLine;
					nextPutAll: 'Initialization code follows:"';
					newLine;
					nextPutAll: sourceCode ] ) ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 5/17/2022 21:46:46'!
createChangeSetPreamble
	"Create a preamble for the change set.."

	baseChangetSet preambleString: 
		(String streamContents: [:strm |
			strm 
				nextPutAll: '"Change Set:'  "NOTE: fileIn recognizes preambles by this string.";
				tab;tab; nextPutAll: baseChangetSet name;
				newLine; nextPutAll: 'Date:'; tab; tab; tab; nextPutAll: Date today printString;
				newLine; nextPutAll: 'Author:'; tab; tab; tab; nextPutAll: Utilities authorName;
				newLine; newLine; nextPutAll: package description;
				nextPut: $" ])! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 22:55:47'!
fileOutChangeSet
	"File out the change set."

	self subclassResponsibility! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 2/19/2022 19:32:08'!
integrate
	"Integrate the package into the system."

	self flagHaver:'This makes devolpment easier.'.	
	package ifNil: [ ^ self ].
	self
		renameIntegrationChangeSet;
		recategorizeMyClasses;
		recategorizeMyExtensionMethods;
		removeMyPackageFromPackageList;
		createChangeSetPreamble;
		createChangeSetPostscript;
		fileOutChangeSet;
		removeMyChangeSet;
		removeMyCategories

! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 5/17/2022 21:47:21'!
integrationChangeSetName
	"Answer the name of the integration change set."

	^ String streamContents: [ :stream |
		ChangeSet currentBaseCSNumber printOn: stream.
		stream
			nextPut: $-;
			nextPutAll: (package packageName);
			nextPut: $-;
			nextPutAll: (Utilities authorName copyReplaceAll: ' ' with: '');
			nextPut: $-.
		DateAndTime now filenamishPrintOn: stream ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 4/9/2022 23:27:14'!
recategorizeMyClasses
	"Recategorize all the classes I contain."

	| suffixStart |
	suffixStart _ package packageName size + 1. "Take the trailing $- into account"
	package classesDo: [ :class | | classCategory categorySuffix |
		"May be empty:"
		categorySuffix _ (classCategory _ class category) copyFrom: suffixStart to: classCategory size.
		self packageCategoriesToSystemCategories 
			at: classCategory
			ifPresent: [ :targetCategory |
				class category: targetCategory, categorySuffix ] ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/14/2021 22:53:50'!
recategorizeMyExtensionMethods
	"Recategorize all the extension methods I contain."

	| start categoriesToRemove |
	categoriesToRemove _ Set new.
	start _ package methodCategoryPrefix size + 2. "Take the leading $* and the trailing $- into account."
	package extensionMethods do: [ :methodReference | | category class |
		(class _ methodReference actualClass)
			addAndClassifySelector: methodReference selector
			withMethod:  methodReference compiledMethod
			inProtocol:  ((category _ methodReference category) copyFrom: start to: category size)
			notifying: nil.
	categoriesToRemove add: {category. class} ].
	categoriesToRemove do: [ :categoryAndClass | | category class |
		category _ categoryAndClass first.
		class _ categoryAndClass second.
		class removeCategory: category ]
		! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 8/27/2021 22:03:25'!
removeMyCategories
	"Remove all my categories."

	package systemCategories do: [ :category |
		SystemOrganization
			superclassOrderIn: category :: reverseDo: [ :class |
				class removeFromSystemUnlogged ].
		SystemOrganization removeCategory: category ]! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 8/30/2021 21:14:45'!
removeMyChangeSet
	"File out the change set."

	ChangeSet removeChangeSet: baseChangetSet! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 5/4/2022 09:39:34'!
removeMyPackageFromPackageList
	"comment stating purpose of message"

	| packageName |
	CodePackage installedPackages includesKey: (packageName _ package packageName) ::
		ifTrue: [ CodePackage deregister: package ]
		ifFalse: [ 
			Transcript
				cr;
				show: 'Package: ';
				show: package;
				show: ' not registered' ].
	self integratedFeatures add: packageName! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 22:59:32'!
renameIntegrationChangeSet
	"Create a new integration change set."

	 
	(baseChangetSet _ ChangeSet changeSetForBaseSystem)
		isEmpty ifFalse:  [
			self warnAboutNonEmptyBaseChangeSet ].
	baseChangetSet name: self integrationChangeSetName
! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 22:59:32'!
warnAboutNonEmptyBaseChangeSet

	^ self notify: 'System base change set has other changes!!'! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'specificiation' stamp: 'KLG 8/27/2021 22:01:40'!
changeSetPostScriptSourceCode
	"Answer a fargetment of source code that is append to the change set as a postscript.
	
	If nil is answered no post script is generated."

	^ nil! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) methodsFor: 'specificiation' stamp: 'KLG 8/27/2021 22:01:47'!
packageCategoriesToSystemCategories
	"Answer a mapping from class categories in this package to the new system categories.
	
	Should be redefined in subclasses if there are any mappings."

	^ IdentityDictionary new! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) class methodsFor: 'instance creation' stamp: 'KLG 8/27/2021 22:07:19'!
forPackage: aPackageNameOrString
	"Answer a new instance of mie for the aPackageNameOrString."

	^ self new package: aPackageNameOrString; yourself! !

!(Modules>>#PackageIntegrators>>#AbstractPackageIntegrator) class methodsFor: 'testing' stamp: 'KLG 5/4/2022 09:42:06'!
isIntegratedFeature: aFeatureName
	"Answer true if aFeatureName is an integrated feature."

	^ IntegratedFeatures
		ifNil: [ false ]
		ifNotNil: [ :featureSet |
			featureSet includes: aFeatureName ]! !

!(Modules>>#PackageIntegrators>>#ChangeSetWritingPackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 22:55:26'!
fileOutChangeSet
	"File out the change set."

	baseChangetSet fileOut! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 22:57:30'!
fileOutChangeSet
	"File out the change set.
	
	Do nothing here."! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) methodsFor: 'integration' stamp: 'KLG 9/8/2021 23:00:13'!
warnAboutNonEmptyBaseChangeSet

	^ Transcript
		newLine;
		show: 'System base change set has other changes!!'! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) methodsFor: 'specificiation' stamp: 'KLG 4/9/2022 23:25:26'!
packageCategoriesToSystemCategories
	"Answer a mapping from class categories in this package to the new system categories."

	systemCategory ifNotNil: [
		^ Dictionary new
			at: package packageName put: systemCategory;
			yourself ].
	^ super packageCategoriesToSystemCategories ! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) methodsFor: 'accessing' stamp: 'KLG 2/19/2022 19:14:48'!
systemCategory
	"Answer the value of systemCategory"

	^ systemCategory! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) methodsFor: 'accessing' stamp: 'KLG 2/19/2022 19:15:34'!
systemCategory: anObject
	"Set the value of systemCategory"

	systemCategory _ anObject! !

!(Modules>>#PackageIntegrators>>#PackageIntegrator) class methodsFor: 'instance creation' stamp: 'KLG 2/19/2022 19:28:42'!
forPackage: aPackageNameOrString systemCategory: aNewSystemCategory
	"Answer a new instance of mie for the aPackageNameOrString and aNewSystemCategory."

	^ self forPackage: aPackageNameOrString ::
		systemCategory: aNewSystemCategory ;
		yourself! !

!(Modules>>#PackageIntegrators>>#ModuleIntegrator) methodsFor: 'accessing' stamp: 'KLG 2/19/2022 18:53:01'!
module
	"Answer the value of module"

	^ module! !

!(Modules>>#PackageIntegrators>>#ModuleIntegrator) methodsFor: 'accessing' stamp: 'KLG 2/19/2022 18:53:46'!
module: anObject
	"Set the value of module"

	module _ anObject! !

!(Modules>>#PackageIntegrators>>#ModuleIntegrator) methodsFor: 'integration' stamp: 'KLG 2/19/2022 18:58:14'!
integrate
	"Integrate the package into the system."

	super integrate.
	module becomeSystemModule! !

!(Modules>>#PackageIntegrators>>#ModuleIntegrator) class methodsFor: 'instance creation' stamp: 'KLG 2/19/2022 18:55:29'!
forModule: aModule systemCategory: aNewSystemCategory
	"Answer a new instance of mie for aModuleand and aNewSystemCategory."

	^ super forPackage: aModule packageName systemCategory: aNewSystemCategory ::
		module: aModule;
		yourself! !

!FeatureRequirement methodsFor: '*PackageIntegrators-testing' stamp: 'KLG 5/4/2022 09:51:17'!
isAlreadySatisfied
	"Answer true if requirement is satisfied by some installed package, or by base system."

	(Feature baseSystemFeature satisfies: self)
		ifTrue: [ ^ true ].
		
	`Modules >>#PackageIntegrators >> #AbstractPackageIntegrator`
		isIntegratedFeature: self name asString :: ifTrue: [
			^ true ].

	^CodePackage installedPackages anySatisfy: [ :package |
		package provides satisfies: self ]! !
