'From Haver 5.0 [latest update: #4636] on 15 June 2021 at 1:27:12 pm'!
'Description I test the grid-layout morph.'!
!provides: 'GridLayoutTest' 1 3!
!requires: 'GridLayout' 1 3 nil!
SystemOrganization addCategory: 'GridLayoutTest'!


!moduleCreation: GridLayoutTest!
Modules newEnvironment: #GridLayoutTest!

!interfacesOf: GridLayoutTest!
Modules environment: #GridLayoutTest ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: GridLayoutTest!
Modules environment: #GridLayoutTest :: 
	import: #(#GridLayoutMorph ) from: #UTI of: Modules>>#GridLayout!

!classDefinition: (Modules>>#GridLayoutTest>>#GridLayoutTest) category: 'GridLayoutTest'!
TestCase subclass: #GridLayoutTest
	instanceVariableNames: 'glm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridLayoutTest'
	inModule: #GridLayoutTest!
!classDefinition: (Modules>>#GridLayoutTest>>#GridLayoutTest) class category: 'GridLayoutTest'!
(Modules>>#GridLayoutTest>>#GridLayoutTest) class
	instanceVariableNames: ''!


!(Modules>>#GridLayoutTest>>#GridLayoutTest) commentStamp: '<historical>' prior: 0!
I test the grid layout test.!

!(Modules>>#GridLayoutTest>>#GridLayoutTest) methodsFor: 'setUp/tearDown' stamp: 'KLG 6/15/2021 13:06:43'!
createGridMorphWithRows: aNumberOfRows andColumns: aNumberOfColumns
	"comment stating purpose of message"

	super setUp.
	(glm _ GridLayoutMorph new)
		numberOfColumns: aNumberOfColumns;
		numberOfRows: aNumberOfRows;
		morphExtent: 400 @ 400;
		submorphCreator: [ :rowNumber : columnNumber | | morph |
			(morph _ LabelMorph contents: rowNumber asString, ' @ ', columnNumber asString)
				setProperty: #rowNumber toValue: rowNumber;
				setProperty: #columnNumber toValue: columnNumber.
			morph ];
		layoutSubmorphs! !

!(Modules>>#GridLayoutTest>>#GridLayoutTest) methodsFor: 'testing' stamp: 'KLG 6/15/2021 13:20:41'!
testLayout
	"Create a grid layout morph and test the layout."

	| expectedColumnNumber expectedRowNumber |
	1 to: 20 do: [ :numberOfRows |
		1 to: 20 do: [ :numberOfColumns |
			self createGridMorphWithRows: numberOfRows andColumns: numberOfColumns.
			glm
				rowAndColumnNumbersWithSubmorphsDo: [ :rowNumber :columnNumber :submorph |
					self
						assert: rowNumber equals: (submorph valueOfProperty: #rowNumber);
						assert: columnNumber equals: (submorph valueOfProperty: #columnNumber) ].
			expectedRowNumber _ 3 min: numberOfRows.
			expectedColumnNumber _ 1.
			glm submorphsInRow: expectedRowNumber do: 	[ :submorph |
				self
					assert: expectedRowNumber equals: (submorph valueOfProperty: #rowNumber);
					assert:  expectedColumnNumber equals: (submorph valueOfProperty: #columnNumber).
				expectedColumnNumber _ expectedColumnNumber + 1 ].
			expectedRowNumber _ 1.
			expectedColumnNumber _ 3 min: numberOfColumns.		
			glm submorphsInColumn: expectedColumnNumber do: [ :submorph |
				self
					assert: expectedRowNumber equals: (submorph valueOfProperty: #rowNumber);
					assert:  expectedColumnNumber equals: (submorph valueOfProperty: #columnNumber).
				expectedRowNumber _ expectedRowNumber + 1 ] ] ]! !
